import React,{Fragment} from 'react';
import UnitInput from './components/UnitInput'
import UnitModal from './components/UnitModal'
import './ItemCard.scss'
export default class ItemCard extends React.Component{
  constructor(props){
    super(props)
  }
  render() {
    return(
      <ul className="item-card ctm-clearfix">
          {
            this.props.columns.map((item,index)=>{
              if(item === {}){
                return <li key={index}></li>
              }
              if(item.type === 'input'){
                return <Fragment>
                          <li key={index}>
                            <ul>
                              <li>{item.title}</li>
                              <li>
                                <UnitInput value={this.props.res[item.dataIndex]} config={item}/>
                              </li>
                            </ul>
                          </li>
                      </Fragment>
              }else if(item.type === 'modal'){
                return <Fragment>
                  <li key={index}>
                    <ul>
                      <li>{item.title}</li>
                      <li><UnitModal value={this.props.res} config={item}/></li>
                    </ul>
                  </li>
                </Fragment>
              }else if(item.render){
                return <Fragment>
                  <li key={index}>
                    <ul>
                      <li>{item.title}</li>
                      <li>{item.render(this.props.res[item.dataIndex])}</li>
                    </ul>
                  </li>
                </Fragment>
              } else {
                return <Fragment>
                            <li key={index}>
                              <ul>
                                <li>{item.title}</li>
                                <li>{this.props.res[item.dataIndex]||undefined}</li>
                              </ul>
                            </li>
                       </Fragment>
              }
            })
          }
      </ul>
    )
  }
}
