import React, { Fragment } from 'react'
import {Table, Divider, Row, Col, Alert, Input, Switch, Button} from 'antd';
const { TextArea } = Input;

export default class ItemProductList extends React.Component{
  constructor(props) {
    super(props);
    this.state = {
      data: [],
      dataStr: '',
      isChange: false
    }
  }

  triggerChange = (changedValue) => {
    // Should provide an event to pass value to Form.
    const onChange = this.props.onChange;
    if (onChange) {
      onChange(changedValue);
    }
  };

  column = [
    {
      title: '商品ID',
      dataIndex: 'product_id',
      key: 'product_id',
      render: (text, record, index) => {
        return (
          <div>
            <Input type="text" value={record.product_id} onChange={(e) => {
              this.state.data[index].product_id = e.target.value;
              this.triggerChange(this.state.data);
            }}/>
          </div>
        );
      }
    },
    {
      title: '价格',
      dataIndex: 'price',
      key: 'price',
      render: (text, record, index) => {
        return (
          <div>
            <Input type="text" value={record.price} onChange={(e) => {
              this.state.data[index].price = e.target.value;
              this.triggerChange(this.state.data);
            }}/>
          </div>
        );
      }
    },
    {
      title: '操作',
      dataIndex: 'action',
      key: 'action',
      render: (text, record, index) => {
        return (
          <div>
            <a onClick={() => {
              this.delProductInfo(index);
              this.triggerChange(this.state.data);
            }}>删除</a>
          </div>
        );
      }
    },
  ];
  // componentWillReceiveProps(props) {
  //   const datasource = props.value || [];
  //   let data = []
  //   if (datasource.length == 0) {
  //     data = []
  //   } else {
  //     data = datasource
  //   }
  //   this.setState({
  //     data: data,
  //   })
  // }
  componentWillReceiveProps(props) {
    if (this.state.isChange) {
      return;
    }
    console.log('componentWillReceiveProps', props.value)
    const datasource = props.value || [];
    let data = [];
    let that = this;
    if (datasource.length == 0) {
      data = []
    } else {
      data = datasource
    }
    this.setState({
      data: data,
    },() => {
      that.getDataStr();
    })
  }

  addProductInfo = () => {
    this.state.data.push({
      product_id: '',
      price: ''
    });
  };

  delProductInfo = (index) => {
    this.state.data.splice(index, 1);
  };

  // componentWillMount() {
  //   const datasource = this.props.value || [];
  //   let data = [];
  //   let that = this;
  //   if (datasource.length == 0) {
  //     data = []
  //   } else {
  //     data = datasource
  //   }
  //   this.setState({
  //     data: data,
  //   },() => {
  //     that.getDataStr();
  //   })
  // }

  reorganizationData = (e) => {
    let currentValue =  e.target.value;
    let currentValueList = currentValue.split('\n');
    let dataList = [];
    for (let index = 0; index < currentValueList.length; index++) {
      const element = (currentValueList[index].trim()).replace(/\n/g,'');
      if(element.trim() != ''){
          // if(!element.split(":")[1] && element.split(":")[0]) {
          //     if(element.split(":").length==1) {
          //         content = content + element.split(":")[0] + "\n";
          //     }else {
          //         content = content + element.split(":")[0] + ":" + "\n";
          //     }
          // }else if(!element.split(":")[0] && element.split(":")[1]) {
          //     content = content + ":" + element.split(":")[1] + "\n";
          // } else if(!element.split(":")[1] && !element.split(":")[0]) {
          //     content = content + ":" + "\n";
          // }
          let dataObj = {};
          dataObj.price = element.split(":")[1];
          dataObj.product_id = element.split(":")[0];
          dataList.push(dataObj);
      }
    }
    this.setState({
      dataStr: currentValue,
      isChange: true
     }, () => {
       this.triggerChange(dataList)
     })
    //  console.log(dataList)
    // this.state.data = dataList;
    // this.triggerChange(dataList);
  }
  
  getDataStr = () => {
    let dataStr = "";
    this.state.data.map((item, index) => {
      dataStr = dataStr + item.product_id + ':' + item.price + "\n";
   })
   this.setState({
    dataStr: dataStr
   })
  }

  render() {
    return (
      <Fragment>
        {/*<Table dataSource={this.source} columns={this.column} />*/}
        <Row gutter={10}>
          <Col span={36} >
            <TextArea rows={10} onChange={(e) => {this.reorganizationData(e)}}
             value={this.state.dataStr} />
            {/* <Table  dataSource={this.state.data} columns={this.column} pagination={false} /> */}
          </Col>
          {/*<Col span={6} >*/}
          {/*  <Table rowKey="type" dataSource={this.state.unused_data} columns={this.unused_columns} bordered title={() => '未选登录方式'} pagination={false} />*/}
          {/*</Col>*/}
        </Row>
        {/* <Button block type={"dashed"} onClick={() => {
          this.addProductInfo();
          this.triggerChange(this.state.data);
        }}> + 添加</Button> */}
      </Fragment>
    );
  }
}
