import React,{Fragment} from 'react'
import { Select, Form } from 'antd';
import HttpClient from '../../../../service/HttpClient'
import Api from '../../../../service/Api'
const Option = Select.Option;
export default class SelectAdd extends React.Component{
  constructor(props){
    super(props);
    this.state = {
      platform: [],
      app: [],
      proSelect:'',
    }
  }
  handlePlatformChange = (id) => {
    this.setState({proSelect:''});
    this.getProjectList({operator_id:id,flatten:1}).then(data => {
      this.setState({
        app: data.list,
      });
    })
  };
  onProjectChange = (value) => {
    this.props.getParams(value);
    this.setState({proSelect:value.id});
    this.getAppList({project_id:value.id,flatten:1}).then(data => {
      this.props.getRadioData(data);
    })
  };
  componentDidMount() {
    this.getPlatForm({limit:100}).then(data => {
      this.setState({
        platform:data,
      })
    })
  }
  async getPlatForm(params){
    return await HttpClient.get(Api.operation_all_platform,params)
  }
  async getProjectList(params){
    return await HttpClient.get(Api.project_list, params)
  }
  async getAppList(params){
    return await HttpClient.get(Api.app_list,params)
  }
  render() {
    const { getFieldDecorator } = this.props.form;
    return(
      <Fragment>
        <Form.Item label={this.props.item.label} {...this.props.formItemLayout}>
          {getFieldDecorator(this.props.item.key.first_key, {
            rules: [
              {
                required: true,
                message: '必须',
              },
            ],
          })(
            <Select className="mr-20" style={{ width: 120 }}>
              {this.state.platform.map(item => <Option key={item.id} onClick={() =>this.handlePlatformChange(item.id)}>{item.name}</Option>)}
            </Select>
          )}
          {getFieldDecorator(this.props.item.key.second_key, {
            rules: [
              {
                required: true,
                message: '必须',
              },
            ],
          })(
            <Select style={{ width: 200 }} value={this.state.proSelect}>
              {this.state.app.map(item => <Option key={item.id} value={[item.name,item.id]} onClick={()=>this.onProjectChange(item)}>{item.name}</Option>)}
            </Select>
          )}
        </Form.Item>
      </Fragment>
    )
  }
}
