import React,{Fragment} from 'react';
import moment from 'moment';
import { withRouter } from "react-router-dom";
import ItemNav from "../../components/ItemNav";
import ItemTableQuery from "../../components/ItemTableQuery";
import ItemTable from "../../components/ItemTable";
import HttpClient from "../../service/HttpClient";
import Api from "../../service/Api";
import { set, get } from "../../service/Global";
import {Tag, Button, Empty, Modal, Table, Input,Form, Select} from 'antd';
import {dateFormat, parseParams} from "../../service/utils";
import {Store} from "marine";
const { TextArea } = Input;
@withRouter
 class MonitorInform extends React.Component{
  constructor(props){
    super(props);
    this.state={
      platData:[],
      dataSource:{
      },
    }
  }
  form;
  defaultParams = {
    page:1,
    pageSize:10
  };
  itemNav = {
    list: [{ anchor: "报警通知" }],
  };
  columns = [
    { title: "ID", dataIndex: "id", key: "id",fixed: 'left',width: 100},
    { title: "平台名称", dataIndex: "platform", key: "platform"},
    { title: "渠道名称", dataIndex: "channel", key: "channel" },
    { title: "提现金额", dataIndex: "amount", key: "amount" },
    { title: "预警时间", dataIndex: "createdAt", key: "createdAt", },
    { title: "单次最高提现", dataIndex: "oneWithdrawal", key: "oneWithdrawal"},
    { title: "单日最高提现", dataIndex: "dayWithdrawal", key: "dayWithdrawal",},
    { title: "单日单用户最高提现", dataIndex: "userDayWithdrawal", key: "userDayWithdrawal",},
    // { title: "预警时间", dataIndex: "operate", key: "operate"},
  ];
 
  getList(params){
    return HttpClient.post(Api.warnLog,{...params}).then(data => {
      this.setState({
        dataSource: data,
      })
    })
  }

  getPlatList(){
    return HttpClient.post(Api.platformList).then(data => {
      let tmp=[]
      for(var i in data){
        if(i!=0){
          let obj= {id:i,name:data[i]}
          tmp.push(obj)
        }
        
      }
      this.setState({
        platData:tmp
      })
    })
  }
  
  
  pager = (page) => {
    this.defaultParams = Object.assign({},this.defaultParams,{page:page});
    this.getList(this.defaultParams);
  };
  getTableQuery=(params)=>{
    if(params['range_picker']){
      console.log(params['range_picker'])
      const [startTime,endTime] = params['range_picker'];
      this.defaultParams = Object.assign(this.defaultParams,{startTime,endTime},{...params});
    }else {
      this.defaultParams = Object.assign(this.defaultParams,{...params});
    }
    delete this.defaultParams.range_picker;
    this.getList(this.defaultParams);
  };
  resetParams = ()=>{
    this.defaultParams = {};
    this.setState({
      tableData:{}
    })
  };

 
 
  showBatchModal = () => {
    this.setState({visible: true,});
  };
 

  componentDidMount() {
    this.getPlatList()
    this.getList(this.defaultParams)
  }

  render() {
    const {platData}=this.state;
    const itemTableQuery= [
         
      {
        label:'选择日期',
        type: "range_picker",
        key: "date",   

      },
      {
        label:'所属平台',
        type:'select',
        key:'platform',
      //  mode:'multiple',
        placeholder:'全部',
        data:platData,
          
      },
     
      {
        type:'input',
        key:'id',
       placeholder:'请输入警告id'
      },
     
      {
        type: "submit",
        extend: false,
        }
    ];
   
   
    return(
      <Fragment>
            <ItemNav itemNav={this.itemNav} />
            <section className='content-base'>
          <div className='mb-20'>
           <ItemTableQuery getTableQuery={this.getTableQuery} resetParams={this.resetParams} itemTableQuery={itemTableQuery} />
            
          </div>
         
          <ItemTable columns={this.columns} dataSource={this.state.dataSource} pager={this.pager} />
        </section>
       
      </Fragment>
    )
  }
}
export default Form.create()(MonitorInform)