import React,{Fragment} from 'react';
import moment from 'moment';
import { withRouter } from "react-router-dom";
import ItemNav from "../../components/ItemNav";
import ItemTableQuery from "../../components/ItemTableQuery";
import ItemTable from "../../components/ItemTable";
import HttpClient from "../../service/HttpClient";
import Api from "../../service/Api";
import { set, get } from "../../service/Global";
import {Tag, Button, Empty, Modal, Table, Input,Form, Popconfirm,message} from 'antd';
import {dateFormat, parseParams} from "../../service/utils";
import {Store} from "marine";
import ItemModal from '../../components/ItemModal/ItemModal';
import ItemForm from '../../components/ItemForm';
const { TextArea } = Input;
@withRouter
 class User extends React.Component{
  constructor(props){
    super(props);
    this.state={
      visible: false,
      visible_edit:false,
    title:'新增用户',
      list:{},
      dataSource:{},
    }
    this.resetModal = React.createRef();
    this.addModal = React.createRef();
  }
  form;
  resetModal;
  addModal;
  defaultParams = {
   page:1,
   pageSize:10
  };
  itemNav = {
    list: [{ anchor: "用户管理" }],
  };
  columns = [
    { title: "姓名", dataIndex: "name", key: "name" },
    { title: "真实姓名", dataIndex: "realName", key: "realName"},
    { title: "手机号", dataIndex: "phone", key: "phone",},
    { title: "邮箱", dataIndex: "email", key: "email", },
    { title: "创建时间", dataIndex: "created_at", key: "created_at",},
    { title: "操作", dataIndex: "operate", key: "operate",render:(text,record)=>{
      return <div>
        <Button type='link start-color' onClick={()=> this.handleStart(record.id,record.status)}>{record.status==0?'启用':'封停'}</Button>
        <Button type='link ' onClick={()=> this.handleEditPwd(record)}>重置密码</Button>
        <Popconfirm
        title="你确定删除吗?"
        onConfirm={()=> this.handleDelete(record)}
        //onCancel={this.cancel}
        okText="Yes"
        cancelText="No"
        >
            <Button type='link ml-20 delete-red' >删除</Button>
        </Popconfirm>
        
      </div>
    }},
  ];
  handleStart(id,status){
      
    return HttpClient.post(Api.setUserStatus,{id:id,status:status==1?2:1}).then(data => {
        this.getList(this.defaultParams);
    })
  }
  handleEditPwd=(list)=>{
    this.setState({
      list:list
  })
    this.resetModal.showModal()
     
  }
  handleDelete=(record)=>{
    return HttpClient.post(Api.deleteUserList,{id:record.id}).then(data => {
        if(data){
            message.success('删除成功！');
            this.getList(this.defaultParams)
        }
        
        
        // this.setState({
        //   dataSource: data,
        // })
      })
  }
  getList(params){
    return HttpClient.post(Api.getUserList,{...params}).then(data => {
      this.setState({
        dataSource: data,
      })
    })
  }


  
  
  pager = (page) => {
    this.defaultParams = Object.assign({},this.defaultParams,{page:page});
    this.getList(this.defaultParams);
  };
  getTableQuery=(params)=>{
   
      this.defaultParams = Object.assign(this.defaultParams,{...params});
   
    this.getList(this.defaultParams);
  };
//   resetParams = ()=>{
//     this.defaultParams = {};
//     this.setState({
//       tableData:{}
//     })
//   };

  handleCancel = () => {
    this.setState({ visible: false,visible_edit:false });
  };
  handleOk=(values)=>{
      
    HttpClient.post(Api.addUser,{...values}).then(data => {
      if(data){
        message.success('操作成功！')
      this.addModal.handleCancel()
      this.getList(this.defaultParams)
    }
    })
   
  }
  handleOkEdit=(values)=>{
    HttpClient.post(Api.rePwd,{id:values.id,pwd:values.pwd}).then(data => {
      if(data){
          message.success('操作成功！')
        this.resetModal.handleCancel()
        this.getList(this.defaultParams)
      }
       
     })
  }
  
 
  showBatchModal = () => {
    this.addModal.showModal()
      
  };
  

  componentDidMount() {
    this.getList(this.defaultParams)
  }

  render() {
    const itemTableQuery= [
         
      {
        type:'input',
        key:'key',
       placeholder:'请输入姓名'
      },
     
      {
        type: "submit",
        extend: false,
        // render: <Fragment>
          
        //   </Fragment>,
      },
    ];
    const { getFieldDecorator } = this.props.form;
    const formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
      },
    };
   const {list,title}=this.state;
   const configAdd={
     title:'添加用户',
     render:[
      {
        label:'姓名',
        type:"input",
        key:'name',
        required:true
      },
      {
        label:'真实姓名',
        type:"input",
        key:'realName',
        required:true
      },
      {
       label:'密码',
       type:"password",
       key:'pwd',
       required:true
     },
     {
      label:'手机号',
      type:"input",
      key:'phone',
      //required:true
    },
    {
      label:'邮箱',
      type:"input",
      key:'email',
      //required:true
    },
    {
      label:'备注',
      type:"input",
      key:'remark',
      //required:true
    }
    ],
    dataSource:list,
    getOutput:this.handleOk,
   }
   const config={
    title:'重置密码',
    render:[
      {
        label:'用户ID',
        type:"input",
        key:'id',
        disabled:true,
        required:true
      },
      {
       label:'密码',
       type:"password",
       key:'pwd',
       required:true
     }
    ],
    dataSource:list,
    getOutput:this.handleOkEdit,
   }
    return(
      <Fragment>
            <ItemNav itemNav={this.itemNav} />
            <section className='content-base'>
          <div className='mb-20 formwrapper'>
            <div className='formBg'><ItemTableQuery getTableQuery={this.getTableQuery} resetParams={this.resetParams} itemTableQuery={itemTableQuery} /></div>
            <Button type='primary' className='ml-20' onClick={()=> this.showBatchModal()}>添加</Button>
          </div>
         
          <ItemTable columns={this.columns} dataSource={this.state.dataSource} pager={this.pager} />
        </section>
        <ItemModal config={configAdd}  ref={r=> this.addModal =r}/>
        <ItemModal config={config}  ref={r=> this.resetModal =r}/>
        
       
      </Fragment>
    )
  }
}
export default Form.create()(User)